-- Test payment
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(118);

set search_path to camper, public;

select has_table('payment');
select has_pk('payment');
select table_privs_are('payment', 'guest', array['SELECT', 'INSERT', 'UPDATE']);
select table_privs_are('payment', 'employee', array['SELECT', 'INSERT', 'UPDATE']);
select table_privs_are('payment', 'admin', array['SELECT', 'INSERT', 'UPDATE', 'DELETE']);
select table_privs_are('payment', 'authenticator', array[]::text[]);

select has_column('payment', 'payment_id');
select col_is_pk('payment', 'payment_id');
select col_type_is('payment', 'payment_id', 'integer');
select col_not_null('payment', 'payment_id');
select col_hasnt_default('payment', 'payment_id');

select has_column('payment', 'company_id');
select col_is_fk('payment', 'company_id');
select fk_ok('payment', 'company_id', 'company', 'company_id');
select col_type_is('payment', 'company_id', 'integer');
select col_not_null('payment', 'company_id');
select col_hasnt_default('payment', 'company_id');

select has_column('payment', 'slug');
select col_is_unique('payment', 'slug');
select col_type_is('payment', 'slug', 'uuid');
select col_not_null('payment', 'slug');
select col_has_default('payment', 'slug');
select col_default_is('payment', 'slug', 'gen_random_uuid()');

select has_column('payment', 'campsite_type_id');
select col_is_fk('payment', 'campsite_type_id');
select fk_ok('payment', 'campsite_type_id', 'campsite_type', 'campsite_type_id');
select col_type_is('payment', 'campsite_type_id', 'integer');
select col_not_null('payment', 'campsite_type_id');
select col_hasnt_default('payment', 'campsite_type_id');

select has_column('payment', 'arrival_date');
select col_type_is('payment', 'arrival_date', 'date');
select col_not_null('payment', 'arrival_date');
select col_hasnt_default('payment', 'arrival_date');

select has_column('payment', 'departure_date');
select col_type_is('payment', 'departure_date', 'date');
select col_not_null('payment', 'departure_date');
select col_hasnt_default('payment', 'departure_date');

select has_column('payment', 'subtotal_nights');
select col_type_is('payment', 'subtotal_nights', 'nonnegative_integer');
select col_not_null('payment', 'subtotal_nights');
select col_hasnt_default('payment', 'subtotal_nights');

select has_column('payment', 'number_adults');
select col_type_is('payment', 'number_adults', 'positive_integer');
select col_not_null('payment', 'number_adults');
select col_hasnt_default('payment', 'number_adults');

select has_column('payment', 'subtotal_adults');
select col_type_is('payment', 'subtotal_adults', 'nonnegative_integer');
select col_not_null('payment', 'subtotal_adults');
select col_hasnt_default('payment', 'subtotal_adults');

select has_column('payment', 'number_teenagers');
select col_type_is('payment', 'number_teenagers', 'nonnegative_integer');
select col_not_null('payment', 'number_teenagers');
select col_hasnt_default('payment', 'number_teenagers');

select has_column('payment', 'subtotal_teenagers');
select col_type_is('payment', 'subtotal_teenagers', 'nonnegative_integer');
select col_not_null('payment', 'subtotal_teenagers');
select col_hasnt_default('payment', 'subtotal_teenagers');

select has_column('payment', 'number_children');
select col_type_is('payment', 'number_children', 'nonnegative_integer');
select col_not_null('payment', 'number_children');
select col_hasnt_default('payment', 'number_children');

select has_column('payment', 'subtotal_children');
select col_type_is('payment', 'subtotal_children', 'nonnegative_integer');
select col_not_null('payment', 'subtotal_children');
select col_hasnt_default('payment', 'subtotal_children');

select has_column('payment', 'number_dogs');
select col_type_is('payment', 'number_dogs', 'nonnegative_integer');
select col_not_null('payment', 'number_dogs');
select col_hasnt_default('payment', 'number_dogs');

select has_column('payment', 'subtotal_dogs');
select col_type_is('payment', 'subtotal_dogs', 'nonnegative_integer');
select col_not_null('payment', 'subtotal_dogs');
select col_hasnt_default('payment', 'subtotal_dogs');

select has_column('payment', 'subtotal_tourist_tax');
select col_type_is('payment', 'subtotal_tourist_tax', 'nonnegative_integer');
select col_not_null('payment', 'subtotal_tourist_tax');
select col_hasnt_default('payment', 'subtotal_tourist_tax');

select has_column('payment', 'total');
select col_type_is('payment', 'total', 'nonnegative_integer');
select col_not_null('payment', 'total');
select col_hasnt_default('payment', 'total');

select has_column('payment', 'currency_code');
select col_is_fk('payment', 'currency_code');
select fk_ok('payment', 'currency_code', 'currency', 'currency_code');
select col_type_is('payment', 'currency_code', 'currency_code');
select col_not_null('payment', 'currency_code');
select col_hasnt_default('payment', 'currency_code');

select has_column('payment', 'down_payment_percent');
select col_type_is('payment', 'down_payment_percent', 'percentage');
select col_not_null('payment', 'down_payment_percent');
select col_has_default('payment', 'down_payment_percent');
select col_default_is('payment', 'down_payment_percent', '1.0');

select has_column('payment', 'zone_preferences');
select col_type_is('payment', 'zone_preferences', 'text');
select col_not_null('payment', 'zone_preferences');
select col_hasnt_default('payment', 'zone_preferences');

select has_column('payment', 'acsi_card');
select col_type_is('payment', 'acsi_card', 'boolean');
select col_not_null('payment', 'acsi_card');
select col_hasnt_default('payment', 'acsi_card');

select has_column('payment', 'payment_status');
select col_is_fk('payment', 'payment_status');
select fk_ok('payment', 'payment_status', 'payment_status', 'payment_status');
select col_type_is('payment', 'payment_status', 'text');
select col_not_null('payment', 'payment_status');
select col_has_default('payment', 'payment_status');
select col_default_is('payment', 'payment_status', 'draft');

select has_column('payment', 'created_at');
select col_type_is('payment', 'created_at', 'timestamp with time zone');
select col_not_null('payment', 'created_at');
select col_has_default('payment', 'created_at');
select col_default_is('payment', 'created_at', 'CURRENT_TIMESTAMP');

select has_column('payment', 'updated_at');
select col_type_is('payment', 'updated_at', 'timestamp with time zone');
select col_not_null('payment', 'updated_at');
select col_has_default('payment', 'updated_at');
select col_default_is('payment', 'updated_at', 'CURRENT_TIMESTAMP');


set client_min_messages to warning;
truncate payment cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, description, max_campers, bookable_nights, active)
values (10, 1, 2, 'Type A', '<p>A</p>', 5, '[1, 7]', true)
;

select throws_ok(
	$$ insert into payment (company_id, campsite_type_id, arrival_date, departure_date, subtotal_nights, number_adults, subtotal_adults, number_teenagers, subtotal_teenagers, number_children, subtotal_children, number_dogs, subtotal_dogs, subtotal_tourist_tax, total, currency_code, zone_preferences, acsi_card) values (1, 10, '2024-07-07', '2024-07-07', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'EUR', '', false) $$,
	'23514', 'new row for relation "payment" violates check constraint "departure_after_arrival"',
	'Should not be able to insert a payment with a departure date equal or before the arrival date (i.e., at least one night)'
);


select *
from finish();

rollback;

